function ButtonTrackingObj(exp, titleName, cm, frame){
   this.VarTrivBtnTracking = new Variable( 'VarTrivBtnTracking', null, 0, cm, frame, exp, titleName, true );
   this.title = null;
}

ButtonTrackingObj.codeToStateMap =
{
	'N' : 'normalState',
	'O' : 'overState',
	'D' : 'downState',
	'A' : 'disabledState',
	'V' : 'visitedState',
	'S' : 'selectedState'
};
ButtonTrackingObj.stateToCodeMap = {};
for (var key in ButtonTrackingObj.codeToStateMap)
	ButtonTrackingObj.stateToCodeMap[ButtonTrackingObj.codeToStateMap[key]] = key;

ButtonTrackingObj.prototype.InitPageTracking = function ( )
{
	var THIS = this;
	var pageTrackData = this.VarTrivBtnTracking.getValue();
	var bDoInit = true;
	try {
	    if (pageTrackData && pageTrackData.length > 0 && pageTrackData != '~~~null~~~')
	    {
	        var topLevelSplit = pageTrackData.split('#');
	        if (topLevelSplit && topLevelSplit.length > 1)
            {
		        var arrIds = topLevelSplit[0].split(',');
		        var arrStatus = topLevelSplit[1].split(',');
		        for( var i=0; i<arrIds.length; i++ )
		        {
			        var id = parseInt( '0x' + arrIds[i] );
			        var status = arrStatus[i];
			        var node = this.FindNode( this.title, id );
			        if( node )
						node.v = ButtonTrackingObj.codeToStateMap[status] || status;
		        }
    		}
        }
    } catch (e) { }
}

ButtonTrackingObj.prototype.FindNode = function( node, id )
{
	if( node.id == id )
		return node;
	
	var match = null;
	if( typeof( node.c ) != 'undefined' ){
		for( var i=0; i<node.c.length; i++ ){
			match = this.FindNode( node.c[i], id );
			if( match != null )
				break;
		}
	}
	
	return match;
}

ButtonTrackingObj.prototype.InternalGetRangeStatus = function( node )
{
	if( node == null )
		return -1;
		
	if( typeof(node.c) == 'undefined' )
	{
		return node.v;
	}
	else
	{
		return 'normalState';
	}
}


ButtonTrackingObj.prototype.GetRangeStatus = function( id, bInit )
{
	var status = -1;
	if ( bInit ) 
		this.InitPageTracking();
	
	status = this.InternalGetRangeStatus( this.FindNode( this.title, id ) );

	return status;
}


ButtonTrackingObj.prototype.InternalSetRangeStatus=function( node, status )
{
	if( node == null )
		return;
	node.v = status;
	if( status == 0 && typeof(node.c)!='undefined')
	{
		for( var i=0; i<node.c.length; i++ )
			this.InternalSetRangeStatus( node.c[i], status ); 
	}
}

ButtonTrackingObj.prototype.SetRangeStatus = function( id, status /*0 or 1 or 2*/)
{
	this.InternalSetRangeStatus( this.FindNode(this.title, id), status );
	
	this.SavePageTracking();
}

ButtonTrackingObj.prototype.IterateTree = function( func )
{
	var stack = [];
	stack.push( this.title );
	var i = 0;
	while( stack.length > 0 )
	{
		var node = stack.shift();
		
		if( typeof(node.c) != 'undefined' )
			stack = node.c.concat(stack);
			
		//do the thing
		func( node, i, stack );
		i++;
	}	
}

ButtonTrackingObj.prototype.SavePageTracking = function()
{
	var fnIsSaveState = window.ObjButton && ObjButton.isSaveState || function () { return false; };
	var hexString = '';
	var arrayIds = [];
	var arrayStatus= [];
	
	this.IterateTree(function(node, i, stack){
		if (fnIsSaveState(node.v))
		{
			arrayIds.push(node.id);
			arrayStatus.push(node.v);
		}
	});
	
	for( var i=0; i<arrayIds.length; i++ )
		hexString += (i > 0 ? ',' : '') + arrayIds[i].toString(16);

	hexString += (arrayIds.length > 0 ? '#' : '');
	
	for (var i = 0; i < arrayStatus.length; i++)
		hexString += (i > 0 ? ',' : '') + (ButtonTrackingObj.stateToCodeMap[arrayStatus[i]] || arrayStatus[i]);

	//LD-8267 - Added a condition to avoid tracking null/empty data unnecessarily
	if (hexString.length > 0 || (myTop.suspendDataCache && myTop.suspendDataCache.indexOf('VarTrivBtnTracking') >= 0) || !this.VarTrivBtnTracking.bSCORM)
		this.VarTrivBtnTracking.set(hexString);
}

var trivBtnTracking = new ButtonTrackingObj(365,'making_money_in_technology_media_and_telecom', 0, 'scorm');
trivBtnTracking.title={id:1,v:0,c:[{id:655155,v:'normalState'},{id:47849,v:'normalState'},{id:50838,v:'normalState'},{id:50845,v:'normalState'},{id:50852,v:'normalState'},{id:50859,v:'normalState'},{id:265103,v:'normalState'},{id:52029,v:'normalState'},{id:58646,v:'normalState'},{id:598617,v:'normalState'},{id:176645,v:'normalState'},{id:293612,v:'normalState'},{id:9201,v:'normalState'},{id:9947,v:'normalState'},{id:575907,v:'normalState'},{id:792169,v:'normalState'},{id:792160,v:'normalState'},{id:1155532,v:'normalState'},{id:1155542,v:'normalState'},{id:1155552,v:'normalState'},{id:1155573,v:'normalState'},{id:1155588,v:'normalState'},{id:1155596,v:'normalState'},{id:1155610,v:'normalState'},{id:720758,v:'normalState'},{id:720746,v:'normalState'},{id:720722,v:'normalState'},{id:720710,v:'normalState'},{id:720698,v:'normalState'},{id:802069,v:'normalState'},{id:1507857,v:'normalState'},{id:1453356,v:'normalState'},{id:1453370,v:'normalState'},{id:1453390,v:'normalState'},{id:1453406,v:'normalState'},{id:1439836,v:'normalState'},{id:1439850,v:'normalState'},{id:1439870,v:'normalState'},{id:1455239,v:'normalState'},{id:1453178,v:'normalState'},{id:1453192,v:'normalState'},{id:1453212,v:'normalState'},{id:1456871,v:'normalState'},{id:1439676,v:'normalState'},{id:1439690,v:'normalState'},{id:1439710,v:'normalState'},{id:1457378,v:'normalState'},{id:1439758,v:'normalState'},{id:1439772,v:'normalState'},{id:1457743,v:'normalState'},{id:1457650,v:'normalState'},{id:1439594,v:'normalState'},{id:1439608,v:'normalState'},{id:1439628,v:'normalState'},{id:1439644,v:'normalState'},{id:1440067,v:'normalState'},{id:1440084,v:'normalState'},{id:1440099,v:'normalState'},{id:1440114,v:'normalState'},{id:1440129,v:'normalState'},{id:1440137,v:'normalState'},{id:1440146,v:'normalState'},{id:1440155,v:'normalState'},{id:1440164,v:'normalState'},{id:1440173,v:'normalState'},{id:1440329,v:'normalState'},{id:1467678,v:'normalState'},{id:1467885,v:'normalState'},{id:1468347,v:'normalState'},{id:1468469,v:'normalState'},{id:1468558,v:'normalState'},{id:1461428,v:'normalState'},{id:1461419,v:'normalState'},{id:1461410,v:'normalState'},{id:1461401,v:'normalState'},{id:1461392,v:'normalState'},{id:1461383,v:'normalState'},{id:1469395,v:'normalState'},{id:1470361,v:'normalState'},{id:1469116,v:'normalState'},{id:1469126,v:'normalState'},{id:1440508,v:'normalState'},{id:1357370,v:'normalState'},{id:1440797,v:'normalState'},{id:1440808,v:'normalState'},{id:1440819,v:'normalState'},{id:1440831,v:'normalState'},{id:1440840,v:'normalState'},{id:1440849,v:'normalState'},{id:1440868,v:'normalState'},{id:1440880,v:'normalState'},{id:1440896,v:'normalState'},{id:1441013,v:'normalState'},{id:1441021,v:'normalState'},{id:1441029,v:'normalState'},{id:1441037,v:'normalState'},{id:1441052,v:'normalState'},{id:1484009,v:'normalState'},{id:1484592,v:'normalState'},{id:1484739,v:'normalState'},{id:1340842,v:'normalState'},{id:1340886,v:'normalState'},{id:1443750,v:'normalState'},{id:1444400,v:'normalState'},{id:1444412,v:'normalState'},{id:1444424,v:'normalState'},{id:1444436,v:'normalState'},{id:1444448,v:'normalState'},{id:1444465,v:'normalState'},{id:1444488,v:'normalState'},{id:1490670,v:'normalState'},{id:1490901,v:'normalState'},{id:1444532,v:'normalState'},{id:1444541,v:'normalState'},{id:1445146,v:'normalState'},{id:1445158,v:'normalState'},{id:1445170,v:'normalState'},{id:1445182,v:'normalState'},{id:1445194,v:'normalState'},{id:1445211,v:'normalState'},{id:1445234,v:'normalState'},{id:1494373,v:'normalState'},{id:1494548,v:'normalState'},{id:1445278,v:'normalState'},{id:1445287,v:'normalState'},{id:1444773,v:'normalState'},{id:1444785,v:'normalState'},{id:1444797,v:'normalState'},{id:1444809,v:'normalState'},{id:1444821,v:'normalState'},{id:1444838,v:'normalState'},{id:1444861,v:'normalState'},{id:1496651,v:'normalState'},{id:1496942,v:'normalState'},{id:1444905,v:'normalState'},{id:1444914,v:'normalState'},{id:1497222,v:'normalState'},{id:1497234,v:'normalState'},{id:1497246,v:'normalState'},{id:1497258,v:'normalState'},{id:1497270,v:'normalState'},{id:1497287,v:'normalState'},{id:1497310,v:'normalState'},{id:1497838,v:'normalState'},{id:1498143,v:'normalState'},{id:1497354,v:'normalState'},{id:1497363,v:'normalState'},{id:1498418,v:'normalState'},{id:1498430,v:'normalState'},{id:1498442,v:'normalState'},{id:1498454,v:'normalState'},{id:1498466,v:'normalState'},{id:1498483,v:'normalState'},{id:1498506,v:'normalState'},{id:1499094,v:'normalState'},{id:1499336,v:'normalState'},{id:1498550,v:'normalState'},{id:1498559,v:'normalState'},{id:1445396,v:'normalState'},{id:1445418,v:'normalState'},{id:1445577,v:'normalState'},{id:1445590,v:'normalState'},{id:1445603,v:'normalState'},{id:1445616,v:'normalState'},{id:1445524,v:'normalState'},{id:1445536,v:'normalState'},{id:1445548,v:'normalState'},{id:1445560,v:'normalState'},{id:1439314,v:'normalState'},{id:1160849,v:'normalState'},{id:1160893,v:'normalState'},{id:70221,v:'normalState'},{id:1445728,v:'normalState'},{id:1445742,v:'normalState'},{id:1025142,v:'normalState'},{id:1025156,v:'normalState'},{id:1025256,v:'normalState'},{id:1025270,v:'normalState'},{id:194542,v:'normalState'},{id:294732,v:'normalState'},{id:1055301,v:'normalState'},{id:1055315,v:'normalState'},{id:323733,v:'normalState'},{id:323725,v:'normalState'},{id:1445800,v:'normalState'},{id:1445814,v:'normalState'},{id:788049,v:'normalState'},{id:788063,v:'normalState'},{id:1246456,v:'normalState'},{id:923590,v:'normalState'},{id:323409,v:'normalState'},{id:323401,v:'normalState'},{id:70100,v:'normalState'},{id:325221,v:'normalState'},{id:325757,v:'normalState'},{id:329044,v:'normalState'},{id:327409,v:'normalState'},{id:625193,v:'normalState'},{id:625135,v:'normalState'},{id:625143,v:'normalState'},{id:625151,v:'normalState'},{id:625159,v:'normalState'},{id:625167,v:'normalState'},{id:233645,v:'normalState'},{id:233637,v:'normalState'},{id:590305,v:'normalState'},{id:590317,v:'normalState'},{id:673002,v:'normalState'},{id:674262,v:'normalState'},{id:590337,v:'normalState'},{id:590345,v:'normalState'},{id:233060,v:'normalState'},{id:233308,v:'normalState'},{id:135253,v:'normalState'},{id:234172,v:'normalState'},{id:233847,v:'normalState'},{id:233839,v:'normalState'},{id:69966,v:'normalState'}]};
